<template>
  <NodeDetailComponent v-model="selectedNode"/>
  <div class="main">
    <div class="pane">
      <div ref="graph" class="graph"/>
      <div class="hint" v-if="!simulation">
        Use the search and the filter tool on the right to fetch and visualize data.
      </div>
    </div>
    <FilterComponent @data="renderData" @limit="updateNodeLimit" @includeReplyingMails="updateIncludingReplyingMails"/>
  </div>
  <div class="fab">
    <button @click="expandAllLeafs">Expand all</button>
    <button @click="cutAllLeafs">Cut all</button>
  </div>
</template>

<script lang="ts">
import {defineComponent} from "vue";
import {Simulation} from "@/typescript/simulation";
import FilterComponent from "@/components/FilterComponent.vue";
import NodeDetailComponent from "@/components/NodeDetailComponent.vue";
import {useToast} from 'vue-toast-notification';

import 'vue-toast-notification/dist/theme-sugar.css';
import dayjs from "dayjs";
import {api} from "@/typescript/api";
import {transformer} from "@/typescript/transformer";

export default defineComponent({
  components: {NodeDetailComponent, FilterComponent},
  data() {
    return {
      selectedNode: null as object | null,
      simulation: null as Simulation | null,
      nodeLimit: null as number | null,
      includeReplyingMails: false,
      newMails: [] as object[],
      currentSeconds: Math.floor(dayjs().unix()), // - 60 * 60 * 24 * 35,
    }
  },
  async mounted() {
    // fetch data every 5 seconds
    setInterval(() => {
      this.fetchNewMail()
    }, 20000)
  },
  methods: {
    /**
     * Render data
     *
     * @param data
     */
    renderData(data: any) {
      this.simulation = new Simulation(this.$refs.graph as HTMLElement)
      this.simulation.on('click', (event: any, d: any) => {
        this.selectedNode = d
      })
      this.simulation.on('data', (data: { nodes: object[] }) => {
        const toast = useToast()
        let message = null
        if (data.nodes.length === 0) {
          message = 'No data found'
        } else if (data.nodes.length >= this.nodeLimit) {
          message = `Limit of ${this.nodeLimit} nodes in this fetch reached. There might be more data available.`
        }

        if (message) {
          toast.open({
            message: message,
            type: 'info',
            position: 'bottom',
            duration: 5000,
          })
        }
      })
      this.simulation.addData(data)
      this.simulation.setLimit(this.nodeLimit ?? 10)
      this.simulation.setIncludingReplyingMails(this.includeReplyingMails)
    },

    /**
     * Update node limit
     *
     * @param limit
     */
    updateNodeLimit(limit: number) {
      this.nodeLimit = limit
      if (this.simulation) {
        this.simulation.setLimit(limit)
      }
    },

    /**
     * Update including replying mails
     *
     * @param includeReplyingMails
     */
    updateIncludingReplyingMails(includeReplyingMails: boolean) {
      this.includeReplyingMails = includeReplyingMails
      if (this.simulation) {
        this.simulation.setIncludingReplyingMails(includeReplyingMails)
      }
    },

    /**
     * Expands all nodes
     */
    expandAllLeafs() {
      if(!this.simulation){
        return
      }
      this.simulation.expandAllLeafs()
    },

    /**
     * Cuts all leafs
     */
    cutAllLeafs() {
      if(!this.simulation){
        return
      }
      this.simulation.cutAllLeafs()
    },

    /**
     * Get the mails since the last fetch.
     *
     */
    async fetchNewMail() {
      const timestamp = dayjs.unix(this.currentSeconds).format('YYYY-MM-DDTHH:mm:ss')
      this.currentSeconds = Math.floor(dayjs().unix())

      const data = transformer.api2graph(
          await api.query(`
          MATCH (n)
          WHERE
          (n:Mail)
          AND (n.date >= datetime('${timestamp}'))
          RETURN n
        `)
      )

      if (data.nodes.length === 0) {
        return
      }

      // add new label to new mails
      data.nodes.forEach((node: any) => {
        node.labels.push('New')
      })

      // add new mails to the simulation
      if (this.simulation) {
        this.simulation.addData(data)
      } else {
        this.renderData(data)
      }

      // play sound
      const audio = new Audio('/audio/sound.mp3')
      await audio.play()
    }
  }
})


</script>

<style>
div.main {
  position: relative;
  width: 100vw;
  height: 100vh;
  display: grid;
  grid-template-columns: 1fr 400px;
  background: #f5f5f5;

  div.pane {
    position: relative;

    div.hint {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: #f5f5f5;
      text-align: center;
      line-height: 100vh;
    }

    div.graph {
      height: 100vh;
      overflow: hidden;

      svg {
        display: block;

        .node {
          &:hover {
            cursor: pointer;
            opacity: .85;
            fill: black !important;
            transition: .125s;
          }

          &.New {
            fill: #d62728;
            filter: drop-shadow(3px 3px 10px rgba(214, 39, 40, 0.5));
            animation: pulse 1s infinite;
          }
        }

        .text {
          fill: #000;
          stroke-width: 0;
          opacity: 0.05;
          font-weight: bold;
          font-size: .35rem;
          cursor: pointer;
          padding: 5rem;

          &:hover {
            opacity: 1;
          }
        }
      }
    }
  }
}

div.v-toast__item--info {
  background: var(--color-accent);
  color: #ffffff;
}

div.fab {
  display: grid;
  grid-template-columns: 1fr 1fr;
  grid-gap: .5rem;
  position: fixed;
  bottom: 1rem;
  left: 1rem;
  width: auto;

}


@keyframes pulse {
  0% {
    filter: drop-shadow(0 0 5px rgba(214, 39, 40, 1));
  }
  50% {
    filter: drop-shadow(0 0 5px rgba(214, 39, 40, 0.25));
  }
  100% {
    filter: drop-shadow(0 0 5px rgba(214, 39, 40, 1));
  }
}
</style>
